
extern "C"
{
  // Global Memory
  extern int loadi( int base, int offset = 0 ) asm("llvm.trax.loadi");
  extern float loadf( int base, int offset = 0 ) asm("llvm.trax.loadf");
  extern void storei( int value, int base, int offset = 0 ) asm("llvm.trax.storei");
  extern void storef( float value, int base, int offset = 0 ) asm("llvm.trax.storef");

  // Arithmetic
  extern int atomicinc( int location) asm("llvm.trax.atominc");
  extern float min( float left, float right ) asm("llvm.trax.min");
  extern float max( float left, float right ) asm("llvm.trax.max");
  extern float invsqrt( float value ) asm("llvm.trax.invsqrt");

  // Debug
  extern void profile( int prof_id ) asm("llvm.trax.profile");
  extern int loadl1( int base, int offset = 0 ) __attribute__ ((pure));
  extern void trax_printi(int value) asm("llvm.trax.printi");
  extern void trax_printf( float value ) asm("llvm.trax.printf");
}

inline void trax_setup() {
  // nothing!
}

inline void trax_cleanup() {
  // nothing!
}


// pthread stuff -> user should defer back to calling functoin themselves
inline bool trax_start_render_threads( void* (*renderFunc)(void*), const int &numThreads=1 ) {
	return false;
}